/********************************************************************
 * map1.c          24-DEC-1991             Y.Takeuchi               *
 *                                                                  *
 * VME mapping sample                                               *
 * Check K2917 interrupt registers                                  *
 *                                                                  *
 * compile: cc -O -o map1 map1.c                                    *
 * usage:   map1                                                    *
 ********************************************************************/
#include <stdio.h>
#include <sys/fcntl.h>
#include <sys/types.h>
#include <sys/file.h>
#include <sys/mman.h>
#include <sbusdev/sfvmereg.h>

#define SIZE 0x800000
#define BASE 0

#define A16_SIZE 0x10000
#define A16_BASE 0x0000

main(argc, argv)
int argc;
char *argv[];
{
    int i, j, a, start_addr, fd, flag, dat, dat1, dat2;
    unsigned char *vaddr_vme;
    caddr_t vaddr;
    char *b_w;

    start_addr = 0;

/* read option */
    a    = (argc > 1) ? atoi(argv[1]) : 16;
    b_w  = (argc > 2) ? argv[2] : "b";
    flag = (argc > 3) ? 1 : 0;

/* open and map VME address space */
    switch (a) {
      case 16:
	fd = open("/dev/sfvme16D16", O_RDWR);
        ioctl(fd, SFVME_SET, &start_addr);
	vaddr = mmap((caddr_t)0, A16_SIZE, PROT_READ | PROT_WRITE,
                      MAP_SHARED, fd, A16_BASE);
	break;

      case 24:
	fd = open("/dev/sfvme24D16", O_RDWR);
        ioctl(fd, SFVME_SET, &start_addr);
	vaddr = mmap((caddr_t)0, SIZE, PROT_READ | PROT_WRITE,
                      MAP_SHARED, fd, BASE);
	break;

      case 32:
	fd = open("/dev/sfvme32D16", O_RDWR);
        ioctl(fd, SFVME_SET, &start_addr);
	vaddr = mmap((caddr_t)0, SIZE, PROT_READ | PROT_WRITE,
                      MAP_SHARED, fd, BASE);
	break;

      default:
	vaddr = (caddr_t)-1;
	break;
    }

    if (vaddr != (caddr_t)-1) {
	vaddr_vme = (unsigned char *)vaddr;
    }
    else {
	printf("ERROR!!\n");
	exit(1);
    }

/* LOOP */
    i = 0xff41;
    for(;;) {
	for (i = 0xff41; i < 0xff44; i+=2) {
	    for (dat = 0xe1; dat < 0x100; dat+=8) {
		*(vaddr_vme + i) = dat;
		printf("write data=0x%02x   vmeA%2dD16[0x%04X]: 0x%02x(B)\n",
		       dat, a, i, *(vaddr_vme + i));
		/*
		  getchar();
		  */
	    }
	}
	printf("\n");
	sleep(1);
    }
}
